
    <!DOCTYPE html>
    <html>
      <head>
        <meta charset="utf-8">
      </head>
      <body>
        <div class="marpit"><svg data-marpit-svg="" viewBox="0 0 1280 5000"><foreignObject width="1280" height="5000"><section id="1" data-marpit-fragments="16">
<h1>SQL</h1>
<p>База данных – центральная часть любого приложения. Она хранит данные, которыми манипулирует код, добавляет их, обновляет и удаляет. Несмотря на то, что базы бывают очень разными, в основе большинства из них лежит общий подход основанный на табличном представлении данных. Для управления данными в этих базах используется язык запросов SQL. Этот язык не зависит от используемого языка программирования и работает одинаково из любой программы.</p>
<h2>Ссылки</h2>
<ul>
<li data-marpit-fragment="1"><a href="https://ru.hexlet.io/courses/rdb-basics">Курс &quot;Основы реляционных баз данных&quot;</a></li>
<li data-marpit-fragment="2"><a href="https://www.h2database.com/html/main.html">База данных H2</a></li>
<li data-marpit-fragment="3"><a href="https://postgrespro.ru/docs/postgrespro/13/datatype">Типы данных SQL</a></li>
<li data-marpit-fragment="4"><a href="https://www.db-fiddle.com/">Онлайн песочница для выполнения SQL запросов</a></li>
</ul>
<h2>solution.sql</h2>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="5">
<p>Составьте запрос, который извлекает имя пользователя (поле <code>first_name</code>) и его дату рождения (поле <code>birthday</code>) из таблицы <code>users</code> по следующим правилам:</p>
<ul>
<li data-marpit-fragment="6">Пользователи должны быть рождены позже 23 октября 1999 года. Поле <code>birthday</code></li>
<li data-marpit-fragment="7">Пользователи отсортированы в алфавитном порядке по полю <code>first_name</code></li>
<li data-marpit-fragment="8">Нужно извлечь только первые три записи</li>
</ul>
</li>
<li data-marpit-fragment="9">
<p>Прежде, чем писать запрос в файл <em>solution</em>, попробуйте поэкспериментировать локально.</p>
<ul>
<li data-marpit-fragment="10">
<p>Установите базу данных H2 к себе на компьютер. Скачайте <a href="https://h2database.com/h2-setup-2019-03-13.exe">установщик</a> для Windows или платформонезависимый архив для других ОС. Для установки запустите установщик или распакуйте архив в директорию по вашему выбору.</p>
</li>
<li data-marpit-fragment="11">
<p>Запустите утилиту H2 Console. Мы будем работать со встроенным вариантом базы данных H2, который работает с базой данных в файле и не требует установки сервера. После запуска утилиты откроется окно в браузере. В поле &quot;JDBC URL&quot; укажите путь к файлу, в котором будет располагаться база данных. Путь можете выбрать по своему усмотрению. После нажатия на кнопку &quot;Connect&quot; утилита создаст файл с базой данных по указанному пути и подключится к ней.</p>
</li>
<li data-marpit-fragment="12">
<p>Скопируйте содержимое файла <em>init.sql</em> в поле для запросов H2 Console и выполните запрос. Этот файл содержит SQL-запросы, которые после выполнения создадут в вашей базе данных новую таблицу и наполнят её данными. Теперь у вас есть заполненная база данных, с которой можно эксперементировать.</p>
</li>
</ul>
</li>
</ul>
<h2>Самостоятельная работа</h2>
<ul>
<li data-marpit-fragment="13">Следуя инструкции из урока <a href="https://ru.hexlet.io/courses/rdb-basics/lessons/install/theory_unit">&quot;Установка&quot;</a> в курсе по реляционным базам данных, установите локально базу PostgreSQL и выполните подключение к ней.</li>
<li data-marpit-fragment="14">По инструкции из урока <a href="https://ru.hexlet.io/courses/rdb-basics/lessons/install/theory_unit">&quot;Подготовка к работе&quot;</a> создайте роль с именем вашего текущего пользователя в системе и базу данных с именем <code>hexlet</code>.</li>
<li data-marpit-fragment="15">Загрузите в базу данных <code>hexlet</code> данные из репозитория <a href="https://github.com/hexlet-components/pg-dump-example">pg-dump-example</a>. В этом репозитории находится дамп — файлы, содержащие структуру и контент базы данных. Склонируйте репозиторий к себе локально, перейдите в его директорию и выполните команду <code>make all</code>. После выполнения команды, созданная база заполнится данными.</li>
<li data-marpit-fragment="16">Подключитесь к базе данных и потренируйтесь выполнять различные запросы.</li>
</ul>
</section>
<script>!function(){"use strict";const t="marpitSVGPolyfill:setZoomFactor,",e=Symbol();let r,o;function n(n){const i="object"==typeof n&&n.target||document,a="object"==typeof n?n.zoom:n;window[e]||(Object.defineProperty(window,e,{configurable:!0,value:!0}),window.addEventListener("message",(({data:e,origin:r})=>{if(r===window.origin)try{if(e&&"string"==typeof e&&e.startsWith(t)){const[,t]=e.split(","),r=Number.parseFloat(t);Number.isNaN(r)||(o=r)}}catch(t){console.error(t)}})));let l=!1;Array.from(i.querySelectorAll("svg[data-marpit-svg]"),(t=>{var e,n,i,s;t.style.transform||(t.style.transform="translateZ(0)");const c=a||o||t.currentScale||1;r!==c&&(r=c,l=c);const d=t.getBoundingClientRect(),{length:u}=t.children;for(let r=0;r<u;r+=1){const o=t.children[r],a=o.getScreenCTM();if(a){const t=null!==(n=null===(e=o.x)||void 0===e?void 0:e.baseVal.value)&&void 0!==n?n:0,r=null!==(s=null===(i=o.y)||void 0===i?void 0:i.baseVal.value)&&void 0!==s?s:0,l=o.firstElementChild,{style:u}=l;u.transformOrigin||(u.transformOrigin=`${-t}px ${-r}px`),u.transform=`scale(${c}) matrix(${a.a}, ${a.b}, ${a.c}, ${a.d}, ${a.e-d.left}, ${a.f-d.top}) translateZ(0.0001px)`}}})),!1!==l&&Array.from(i.querySelectorAll("iframe"),(({contentWindow:e})=>{null==e||e.postMessage(`${t}${l}`,"null"===window.origin?"*":window.origin)}))}r=1,o=void 0;const i=(t,e,r)=>{if(t.getAttribute(e)!==r)return t.setAttribute(e,r),!0};function a({once:t=!1,target:e=document}={}){const r="Apple Computer, Inc."===navigator.vendor?[n]:[];let o=!t;const a=()=>{for(const t of r)t({target:e});!function(t=document){Array.from(t.querySelectorAll('svg[data-marp-fitting="svg"]'),(t=>{var e;const r=t.firstChild,o=r.firstChild,{scrollWidth:n,scrollHeight:a}=o;let l,s=1;if(t.hasAttribute("data-marp-fitting-code")&&(l=null===(e=t.parentElement)||void 0===e?void 0:e.parentElement),t.hasAttribute("data-marp-fitting-math")&&(l=t.parentElement),l){const t=getComputedStyle(l),e=Math.ceil(l.clientWidth-parseFloat(t.paddingLeft||"0")-parseFloat(t.paddingRight||"0"));e&&(s=e)}const c=Math.max(n,s),d=Math.max(a,1),u=`0 0 ${c} ${d}`;i(r,"width",`${c}`),i(r,"height",`${d}`),i(t,"preserveAspectRatio",getComputedStyle(t).getPropertyValue("--preserve-aspect-ratio")||"xMinYMin meet"),i(t,"viewBox",u)&&t.classList.toggle("__reflow__")}))}(e),o&&window.requestAnimationFrame(a)};return a(),()=>{o=!1}}const l=Symbol(),s=document.currentScript;((t=document)=>{if("undefined"==typeof window)throw new Error("Marp Core's browser script is valid only in browser context.");if(t[l])return t[l];const e=a({target:t}),r=()=>{e(),delete t[l]};Object.defineProperty(t,l,{configurable:!0,value:r})})(s?s.getRootNode():document)}();
</script></foreignObject></svg></div>
      </body>
    </html>
  
